<?php
/**
 * The template for displaying image attachments.
 *
 * @package Generate
 */

get_header();
?>

	<div id="primary" <?php generate_content_class('image-attachment'); ?>>
		<main id="main" class="site-main" role="main">

		<?php while ( have_posts() ) : the_post(); ?>

			<article id="post-<?php the_ID(); ?>" <?php post_class(); ?>>
				<div class="inside-article">
					<header class="entry-header">
						<?php the_title( '<h1 class="entry-title">', '</h1>' ); ?>

						<div class="entry-meta">
							<?php
								$metadata = wp_get_attachment_metadata();
								printf( __( 'Опубликовано <span class="entry-date"><time class="entry-date" datetime="%1$s">%2$s</time></span> at <a href="%3$s" title="Ссылка на полноразмерное изображение">%4$s &times; %5$s</a> - <a href="%6$s" title="Вернуться к  %7$s" rel="gallery">%8$s</a>', 'generate' ),
									esc_attr( get_the_date( 'c' ) ),
									esc_html( get_the_date() ),
									esc_url( wp_get_attachment_url() ),
									$metadata['width'],
									$metadata['height'],
									esc_url( get_permalink( $post->post_parent ) ),
									esc_attr( strip_tags( get_the_title( $post->post_parent ) ) ),
									get_the_title( $post->post_parent )
								);

								//edit_post_link( __( 'Edit', 'generate' ), '<span class="edit-link">', '</span>' );
							?>
						</div><!-- .entry-meta -->
					</header><!-- .entry-header -->

					<div class="entry-content">
						<div class="entry-attachment">
							<div class="attachment">
								<?php generate_the_attached_image(); ?>
							</div><!-- .attachment -->

							<?php if ( has_excerpt() ) : ?>
							<div class="entry-caption">
								<?php the_excerpt(); ?>
							</div><!-- .entry-caption -->
							<?php endif; ?>
						</div><!-- .entry-attachment -->

						<?php
							the_content();
							wp_link_pages( array(
								'before' => '<div class="page-links">' . __( 'Страницы:', 'generate' ),
								'after'  => '</div>',
							) );
						?>
					</div><!-- .entry-content -->

					<footer class="entry-meta">
						<nav role="navigation" id="image-navigation" class="image-navigation">
							<div class="nav-previous"><span class="prev"><?php previous_image_link( false, __( 'Предыдущие', 'generate' ) ); ?></span></div>
							<div class="nav-next"><span class="next"><?php next_image_link( false, __( 'Следующие', 'generate' ) ); ?></span></div>
						</nav><!-- #image-navigation -->
						<?php
							if ( comments_open() && pings_open() ) : // Comments and trackbacks open
								printf( __( '<a class="comment-link" href="#respond" title="Разместить комментарий">Разместить комментарий</a> или ссылку: <a class="trackback-link" href="%s" title="Ссылка на ваш пост" rel="trackback">Ссылка</a>.', 'generate' ), esc_url( get_trackback_url() ) );
							elseif ( ! comments_open() && pings_open() ) : // Only trackbacks open
								printf( __( 'Комментарии закрыты, но вы можете оставить ссылку: <a class="trackback-link" href="%s" title="Ссылка на ваш пост" rel="trackback">Ссылка</a>.', 'generate' ), esc_url( get_trackback_url() ) );
							elseif ( comments_open() && ! pings_open() ) : // Only comments open
								 _e( 'Ссылки закрыты, но вы можете <a class="comment-link" href="#respond" title="Разместить комментарий">оставить комментарий</a>.', 'generate' );
							elseif ( ! comments_open() && ! pings_open() ) : // Comments and trackbacks closed
								_e( 'Both comments and trackbacks are currently closed.', 'generate' );
							endif;

							edit_post_link( __( 'Редактировать', 'generate' ), ' <span class="edit-link">', '</span>' );
						?>
					</footer><!-- .entry-meta -->
				</div><!-- .inside-article -->
			</article><!-- #post-## -->

			<?php
				// If comments are open or we have at least one comment, load up the comment template
				if ( comments_open() || '0' != get_comments_number() )
					comments_template();
			?>

		<?php endwhile; // end of the loop. ?>

		</main><!-- #main -->
	</div><!-- #primary -->

<?php 
do_action('generate_sidebars');
get_footer(); ?>