<?php
/**
 * The template part for displaying a message that posts cannot be found.
 *
 * Learn more: http://codex.wordpress.org/Template_Hierarchy
 *
 * @package Generate
 */
?>

<section class="no-results not-found">
	<header class="page-header">
		<h1 class="page-title"><?php _e( 'Ничего не найдено', 'generate' ); ?></h1>
	</header><!-- .page-header -->

	<div class="page-content">
		<div class="inside-article">
			<?php if ( is_home() && current_user_can( 'publish_posts' ) ) : ?>

				<p><?php printf( __( 'Готовы опубликовать свой первый пост? <a href="%1$s">Начните отсюда</a>.', 'generate' ), esc_url( admin_url( 'post-new.php' ) ) ); ?></p>

			<?php elseif ( is_search() ) : ?>

				<p><?php _e( 'Извините, но по Вашему запросу ничего не было найдено. Попробуйте изменить ключевые слова.', 'generate' ); ?></p>
				<?php get_search_form(); ?>

			<?php else : ?>

				<p><?php _e( 'Кажется мы ничего не нашли. Попробуйте поиск.', 'generate' ); ?></p>
				<?php get_search_form(); ?>

			<?php endif; ?>
		</div><!-- .inside-article -->
	</div><!-- .page-content -->
</section><!-- .no-results -->
